#pragma once

#include "codec.hh"
#include "params.hh"

#include "IEEE1609dot2BaseTypes.hh"

class ieee_1609dot2_base_types_public_encryption_key : public codec<IEEE1609dot2BaseTypes::PublicEncryptionKey, IEEE1609dot2BaseTypes::PublicEncryptionKey>
{
public:
  explicit ieee_1609dot2_base_types_public_encryption_key() : codec<IEEE1609dot2BaseTypes::PublicEncryptionKey, IEEE1609dot2BaseTypes::PublicEncryptionKey>() { };
  virtual ~ieee_1609dot2_base_types_public_encryption_key() { };

  virtual int encode (const IEEE1609dot2BaseTypes::PublicEncryptionKey& p_public_encryption_key, OCTETSTRING& p_data);
  virtual int decode (const OCTETSTRING& p_data, IEEE1609dot2BaseTypes::PublicEncryptionKey& p_public_encryption_key, params* p_params = NULL);
}; // End of class ieee_1609dot2_base_types_public_encryption_key

