#pragma once

#include "codec.hh"
#include "params.hh"

#include "IEEE1609dot2BaseTypes.hh"

class ieee_1609dot2_base_types_public_verification_key : public codec<IEEE1609dot2BaseTypes::PublicVerificationKey, IEEE1609dot2BaseTypes::PublicVerificationKey>
{
public:
  explicit ieee_1609dot2_base_types_public_verification_key() : codec<IEEE1609dot2BaseTypes::PublicVerificationKey, IEEE1609dot2BaseTypes::PublicVerificationKey>() { };
  virtual ~ieee_1609dot2_base_types_public_verification_key() { };

  virtual int encode (const IEEE1609dot2BaseTypes::PublicVerificationKey& p_public_verification_key, OCTETSTRING& p_data);
  virtual int decode (const OCTETSTRING& p_data, IEEE1609dot2BaseTypes::PublicVerificationKey& p_public_verification_key, params* p_params = NULL);
}; // End of class ieee_1609dot2_base_types_public_verification_key

